/*!
 * Copyright(2010) Chazaq Dev
 * http://chazaqdev.com
 *
 * Date: Sun Aug 2
 */

	// Base image width x height
	var ORIGIN = 945.0;

	// Base of arrow (bottom block part)
	var BASE_WIDTH 	= 92.0;
	var BASE_HEIGHT	= 132.0;
	// Triangle part of arrow (top triangle part)
	var TRIA_HEIGHT	= 124.0;
	var TRIA_WIDTH	= 208.0;
	// The thickness of the stroke
	var STROKE_WIDTH = 10.0;
	// The default canvas for an arrow
	var CANVAS_BLOCK = 0.0;
	// Length of the "ears" of the arrow"
	var EAR_LENGTH = (TRIA_WIDTH - BASE_WIDTH)/2;
	
	var BLUE_TO_YELLOW	= 166.0;
	var BLUE_TO_MID 	= 30.0;
	var RED_TO_ORANGE 	= 78.0;

	var arrowArray = [];

	//OOP representation of an arrow
	function arrow(arrowName, arrowRGBA, arrowRotate, startX, endX, startY, endY) {
		this.arrowName = arrowName;
		this.arrowRGBA = arrowRGBA;
		this.arrowRotate = arrowRotate;
		this.startX = startX;
		this.endX = endX;
		this.startY = startY;
		this.endY = endY;
	}

	//Adds the arrow element to the document
	var addArrowDiv = function(arrowName) {
		var r = ("<canvas id=\"arrow_" + arrowName + "\" width=\"" + CANVAS_BLOCK + "\" height=\"" + CANVAS_BLOCK 
			+ "\" style=\"position:absolute\">canvas not support by your browser</canvas>");
		$("#mainPage").append(r);
	}


	//Add arrow to the canvas
	var addArrow = function(arrowName, arrowRGBA, arrowRotate, startX, endX, startY, endY, transX, transY) {
		addArrowDiv(arrowName);
		$("#arrow_" + arrowName).css({left:startX, top: startY, opacity: 0.1});
		var the_arrow = new arrow(arrowName, arrowRGBA, arrowRotate, startX, endX, startY);
		var ctx = document.getElementById("arrow_" + arrowName).getContext('2d');
		var half = CANVAS_BLOCK/2;
//		ctx.save();
		ctx.translate(transX,transY);
		ctx.rotate(arrowRotate);
		ctx.shadowOffsetX = 10;
		ctx.shadowOffsetY = 10;
		ctx.shadowBlur = 10;
		ctx.shadowColor = "black";
		ctx.fillStyle = arrowRGBA;
		ctx.lineWidth = STROKE_WIDTH;
		ctx.beginPath();
		ctx.moveTo(half, STROKE_WIDTH);
		ctx.lineTo(half+TRIA_WIDTH/2, TRIA_HEIGHT+STROKE_WIDTH);
		ctx.lineTo(half+TRIA_WIDTH/2-EAR_LENGTH, TRIA_HEIGHT+STROKE_WIDTH);
		ctx.lineTo(half+TRIA_WIDTH/2-EAR_LENGTH, TRIA_HEIGHT+BASE_HEIGHT+STROKE_WIDTH);
		ctx.lineTo(half+TRIA_WIDTH/2-EAR_LENGTH-BASE_WIDTH, TRIA_HEIGHT+BASE_HEIGHT+STROKE_WIDTH);
		ctx.lineTo(half-TRIA_WIDTH/2+EAR_LENGTH, TRIA_HEIGHT+STROKE_WIDTH);
		ctx.lineTo(half-TRIA_WIDTH/2, TRIA_HEIGHT+STROKE_WIDTH);
		ctx.lineTo(half,STROKE_WIDTH);
		ctx.closePath();
		ctx.stroke();
		ctx.fill();

//		ctx.restore();
		$("#arrow_" + arrowName).animate({left: endX, top:endY, opacity: 1.0}, "slow");
		
	}

	//Make sure that the animation will fit in the viewport
	var normalizeSizes = function() {
		var screen_height = $(window).height();
		if (screen_height > $(window).width()) {
			screen_height = $(window).width();
		}
		BASE_WIDTH 	= BASE_WIDTH*screen_height/ORIGIN;
		BASE_HEIGHT	= BASE_HEIGHT*screen_height/ORIGIN;
		TRIA_HEIGHT	= TRIA_HEIGHT*screen_height/ORIGIN;
		TRIA_WIDTH	= TRIA_WIDTH*screen_height/ORIGIN;
		STROKE_WIDTH	= STROKE_WIDTH*screen_height/ORIGIN;
	
		BLUE_TO_YELLOW	= BLUE_TO_YELLOW*screen_height/ORIGIN;
		BLUE_TO_MID 	= BLUE_TO_MID*screen_height/ORIGIN;
		RED_TO_ORANGE 	= RED_TO_ORANGE*screen_height/ORIGIN;
		EAR_LENGTH = (TRIA_WIDTH - BASE_WIDTH)/2;
		
		CANVAS_BLOCK = BASE_HEIGHT + TRIA_HEIGHT+STROKE_WIDTH*2;
	}



	$(document).ready(function(){
		normalizeSizes();
		addArrow("red", "rgb(255,0,0)" ,(Math.PI/2), 
			1, 
			CANVAS_BLOCK+20, 
			CANVAS_BLOCK+BLUE_TO_MID-TRIA_WIDTH/2, 
			CANVAS_BLOCK+BLUE_TO_MID-TRIA_WIDTH/2, 
			CANVAS_BLOCK, 0);
		addArrow("orange", "rgb(255,92,15)" ,(3*Math.PI/2), 
			$(window).width()+CANVAS_BLOCK+20, 
			CANVAS_BLOCK+20+RED_TO_ORANGE+CANVAS_BLOCK, 
			CANVAS_BLOCK+BLUE_TO_MID-TRIA_WIDTH/2, 
			CANVAS_BLOCK+BLUE_TO_MID-TRIA_WIDTH/2,
			0,CANVAS_BLOCK);
		addArrow("yellow", "rgb(255,255,0)" ,0, 
			CANVAS_BLOCK+20+RED_TO_ORANGE/2+CANVAS_BLOCK, 
			CANVAS_BLOCK+20+RED_TO_ORANGE+TRIA_WIDTH/2, 
			$(window).height()+CANVAS_BLOCK, 
			CANVAS_BLOCK+BLUE_TO_YELLOW, 
			0, 0);
		addArrow("blue", "rgb(0,0,255)" ,(Math.PI), 
			CANVAS_BLOCK+20+RED_TO_ORANGE/2+CANVAS_BLOCK, 
			CANVAS_BLOCK+20+RED_TO_ORANGE+TRIA_WIDTH/2, 
			-CANVAS_BLOCK, 
			0, 
			CANVAS_BLOCK, CANVAS_BLOCK);
		
     	});
